package javax.jws.soap;

import java.lang.annotation.ElementType;
import java.lang.annotation.Target;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Retention;

@Retention(RetentionPolicy.RUNTIME)
@Target({ ElementType.TYPE, ElementType.METHOD })
public @interface SOAPBinding {
    public abstract SOAPBinding.Style style() default SOAPBinding.Style.DOCUMENT;
    
    public abstract SOAPBinding.Use use() default SOAPBinding.Use.LITERAL;
    
    public abstract SOAPBinding.ParameterStyle parameterStyle() default SOAPBinding.ParameterStyle.WRAPPED;
    
    public enum Style
    {
        DOCUMENT, 
        RPC;
    }
    
    public enum Use
    {
        LITERAL, 
        ENCODED;
    }
    
    public enum ParameterStyle
    {
        BARE, 
        WRAPPED;
    }
}
